/*
OK lets give credit where credit is due!

First the outline for this code was written by Woody Miller. I've since dumped
that code because of some differences between the Linux 2.4 & Linux 2.6 code.
But I couldn't have gotten this far without his help

Then Dave Houston (http://www.mbx-usa.com/), Dave has ton's of info on how the
X10 (RF & powre line) breaks down.

Next, I use the CM19A java code I found with google. In that code I found the
init sequence for the CM19A. It init's the CM19A so it can receive RF commands
from the CR14A (Pan 'n Title Remote). The name in the code was Jan Roberts
but on the email it referenced Judy Kerr. So credit to both.

Here's a note from Woody (he's working on the CM15A which I hope to have
soon):

5a's I understand, but 5b and 5d's seem to be a bit confusing. 5a'a are plc
stuff (a-1, a-on, etc).  5b seem to be from a macro action, and 5d from an
rf rec'd

Here's the code I got for decoding the RF from the cm15a....

 else if(buf[0]==0x5d)
 {

  printf("%s RF command:===========================",TS());
  for(i=0;i<size;i++)
  {
   printf("%02X ",buf[i]);
  }
  printf("\n");
  fflush(stdout);


  hc=buf[2]>>4;
  if(!(buf[4]&0x80))
  {
   dev=0;
   if(buf[4]&0x40)dev=dev+4;
   if(buf[4]&0x10)dev=dev+1;
   if(buf[4]&0x08)dev=dev+2;
   if(buf[2]&0x0f)dev=dev+8;
   lastdev=dev;
   dev++;

   printf("%s RF:  %c-%-2d %s\n",TS(),urfhc[hc],dev,buf[4]&0x20?"Off":"On");

   fun=2+((buf[4]&0x20)>0);
   devstats[urfhc[hc]-'A'][lastdev]=states[fun];
  }
  else
  {
   printf("%s RF:  %c-%s\n",TS(),urfhc[hc],buf[4]&0x10?"Dim":"Bri");

   fun=4+((buf[4]&0x10)==0);
   devstats[urfhc[hc]-'A'][lastdev]=states[fun];
  }
  fflush(stdout);
 }

*/

/*
  History:

  2004/11/08 njc I've got the base code working pretty well as I can now
                 properly communicate with the first CM19A (I won't test with
		 a second). The receive is still a little buggy looking
		 (doesn't agree with the code tables) but I'm not sure if that's
		 my problem or else where. Now it on to cleaning up the code.
		 Then on to decipering the codes.

  2004/11/11 njc I've modified the code to support either the CM19A or the CM15A
                 This won't continue for very long as the two are different and
		 will require different code to support the extra devices of the
		 CM15A. So far I can read the CM15A's A5's with no problems. Now
		 to write the device and give it it's time.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <signal.h>

#include <errno.h>
extern int errno;

#include <usb.h>

#include "ownet.h"

usb_dev_handle *portnum;

#ifdef CM19A
#define Vendor 	0x0bc7
#define ProdID 	2

#define EP1	0x81  // Input
#define EP2	0x02  // Output

#else
#ifdef CM15A
#define Vendor 0x0bc7
#define ProdID 1

#define EP1	0x81  // Input
#define EP2	0x02  // Output

#endif
#endif

#define USB_PATH "/proc/bus/usb"

// =[ TS() ]==================================================================

char *TS(void) {
  static char ts[100];
  time_t now;
  struct tm *lnow;


  time(&now);
  lnow=localtime(&now);

  sprintf(ts,"%02d/%02d %02d:%02d:%02d",
	  lnow->tm_mon+1,lnow->tm_mday,
	  lnow->tm_hour, lnow->tm_min,lnow->tm_sec);

  return ts;
}

// =[ dumpinhex() ]===========================================================

void
dumpinhex(uchar *buf,int size) {
  int i;
  static lastdev = -1;
  static lasthc  = -1;
  int hc;
  int fun;

  printf("%s ?: ",TS());
  
 if(buf[0] == 0x20) {
 } // else {
  for(i=0;i<size;i++) {
    printf("%02X ",buf[i]);
  }
  // }
  printf("\n");
  fflush(stdout);
}

// =[ myGetDevice() ]=========================================================

usb_dev_handle *
GetFirstDevice(int vendorid, int productid) {
  struct usb_bus    *bus;
  struct usb_device *dev;

  usb_dev_handle    *device_handle = NULL; // it's a null

  usb_init();
  usb_set_debug(3);		/* 3 is the max setting */

  usb_find_busses();
  usb_find_devices();
 
  // Loop through each bus and device until you find the first match
  // open it and return it's usb device handle

  for (bus = usb_busses; bus; bus = bus->next) {
    for (dev = bus->devices; dev; dev = dev->next) {
      //if (dev->descriptor.idVendor == vendorid && dev->descriptor.idProduct == productid) {	
      if (dev->descriptor.idVendor == vendorid) {	
	device_handle = usb_open(dev);
	//
	// Need error checking for when the device isn't found!
	//
	if(!device_handle) {
	  // errno = Exxxxx;      // usb_open should set the error code.
	  return NULL;
	}
	printf("   Full path  %s/%s/%s\n", USB_PATH, dev->bus->dirname, dev->filename);
	return (device_handle);  	
      }	
    }
  }
  errno = ENOENT;		// No such device
  return (device_handle);  	
}

// =[ ahpRead() ]=============================================================

/*
  In an excellent example of sacrificing backward compatability
  for conformance to some proported "standard", the latest Linux
  kernel USB drivers (uhci-alternate in 2.4.24+, and uhci in 2.6.x)
  no longer support low speed bulk mode transfers-- they give
  "invalid argument", errno=-22, on any attempt to do a low speed
  bulk write.  Thus, we need interrupt mode transfers, which are
  only available via the CVS version of libusb.

  (Thanks to Steven Michalske for diagnosing the true problem here.)
*/

SMALLINT ahpRead(usb_dev_handle *hDevice, uchar *buffer, ushort *pnBytes){

  // Synchronous read:
  ulong	nBytes = *pnBytes;

  // read
  //nBytes = usb_bulk_read(hDevice,	 // handle (Not in 2.6)
  nBytes = usb_interrupt_read(hDevice,	 // handle
			      EP1, 	 // which endpoint to read from
			      buffer,	 // buffer to contain read results
			      *pnBytes,	 // number of bytes to read
			      100);      // libusb timeout mS (does not work)

  if (nBytes < 0) {
    OWERROR(OWERROR_ADAPTER_ERROR);
    return FALSE;
  } else {
    *pnBytes = (ushort)nBytes;
    return TRUE;
  }
}

// =[ ahpInit() ]=============================================================

int
ahpInit(usb_dev_handle *handle) {
  int ret;

  // Send this out on the control pipe
  uchar write_ok[] = { 0x20, 0x34, 0xcb, 0x58, 0xa7 };
  uchar init1[]    = { 0x80, 0x01, 0x00, 0x20, 0x14 };
  uchar init2[]    = { 0x80, 0x01, 0x00, 0x00, 0x14, 0x24, 0x20, 0x20 };

  ret = usb_interrupt_write(handle, EP2, write_ok, 5, 5000);
  printf("Wrote (%d) bytes\n", ret);

  sleep(1);

  ret = usb_interrupt_write(handle, EP2, init1, 5, 5000);
  printf("Wrote (%d) bytes\n", ret);

  sleep(1);

  ret = usb_interrupt_write(handle, EP2, init2, 8, 5000);
  printf("Wrote (%d) bytes\n", ret);

  sleep(1);
}

// =[ byebye() ]==============================================================

void
byebye() {
  int rtn;

  usb_set_debug(0);		// We don't need this here
  printf("Done, bye-bye\n");
  rtn = usb_release_interface(portnum, 0);
  //printf("Rtn = %d\n", rtn);
  usb_close(portnum);
  exit(errno);
}

// =[ main() ]================================================================

// Turns out that these USB devices are pretty simple.
//
// First you find them (we grab the first one on the bus)
// open it
//   set it's configuration
//   clain the interface
//     and then read/write to it.
//   When done release it
// and fianlly close it

int main(int argc,char *argv[]) {
  int send_status = -1;
  int open_status = -1;
  int ret	  = -1;

  uchar readbuf[8+1];
  uchar writebuf[] = { 0x20, 0x60, 0x9f, 0x20, 0xdf }; // A1AOFF

  int i,j;

  // One of these is ^C
  signal(SIGINT,  byebye);	// Interrupt from keyboard (^C)
  signal(SIGHUP,  byebye);	// Hangup detected on controlling terminal or death of controlling process
  signal(SIGQUIT, byebye);	// Quit from keyboard (core dump)
  signal(SIGABRT, byebye);	// Abort signal from abort(3)

  // Find the 1st occurance of device, open it and return it's device handle
  portnum = GetFirstDevice(Vendor, ProdID);
  
  if(!portnum) {
    perror("Error opening device");
    exit(errno);
  }

  // Set which configuration (it only has 1)
  open_status = usb_set_configuration(portnum, 1);

  if(open_status < 0) {
    perror("Error claiming the interface");
    byebye();
  }

  // Claim the first (and only) interface
  open_status = usb_claim_interface(portnum, 0);
  
  if(open_status < 0) {
    perror("Error claiming the interface");
    byebye();
  }

#ifdef CM19A
  ahpInit(portnum);		// Init CM19A so it regonizes CR14A remote
#endif

  do {
    ret = usb_interrupt_read(portnum,	 // handle
			     EP1, 	 // which endpoint to read from
			     readbuf,	 // buffer to contain read results
			     8,	         // number of bytes to read
			     5000);      // libusb timeout mS (does not work)
    if(ret < 0 && ret != -110) { // 110 = resource budy
      printf("\nIntRead error: (%d)\n", errno);
      perror("IntRead error: ");
    } else {
      if(ret > 0) {
	dumpinhex(readbuf, ret);
	i = 10;
      }
    }
  } while(ret);	//flush any stuff...

  printf("\n");

  ret = usb_interrupt_write(portnum, EP2, writebuf, 5, 5000);
  printf("Wrote (%d) bytes (%s)\n", ret, usb_strerror());

  errno = 0;

  i = 10;

  do {
    ret = usb_interrupt_read(portnum,	 // handle
			     EP1, 	 // which endpoint to read from
			     readbuf,	 // buffer to contain read results
			     8,	         // number of bytes to read
			     500);       // libusb timeout mS (does not work)


    if(ret < 0 && ret != -110) { // 110 = resource budy
      printf("\nIntRead error: (%d)\n", errno);
      perror("IntRead error: ");
      if(!i--)			// 10 trys in a row and we exit
	byebye();
    } else {
      if(ret > 0) {
	dumpinhex(readbuf,ret);
	i = 10;
      }
    }

  } while(1);

  byebye();

  exit(0);
}

// =[ USB Information ]=======================================================

/*
CM15A
  T:  Bus=01 Lev=01 Prnt=01 Port=01 Cnt=01 Dev#= 12 Spd=1.5 MxCh= 0
  D:  Ver= 1.10 Cls=00(>ifc ) Sub=00 Prot=00 MxPS= 8 #Cfgs=  1
  P:  Vendor=0bc7 ProdID=0001 Rev= 1.00
  S:  Manufacturer=X10 Wireless Technology Inc
  S:  Product=USB ActiveHome Interface
  C:* #Ifs= 1 Cfg#= 1 Atr=e0 MxPwr=  2mA
  I:  If#= 0 Alt= 0 #EPs= 2 Cls=00(>ifc ) Sub=00 Prot=00 Driver=usbdevfs
  E:  Ad=81(I) Atr=03(Int.) MxPS=   8 Ivl=10ms
  E:  Ad=02(O) Atr=03(Int.) MxPS=   8 Ivl=10ms

CM19A
  T:  Bus=04 Lev=01 Prnt=01 Port=00 Cnt=01 Dev#=  2 Spd=1.5 MxCh= 0
  D:  Ver= 1.10 Cls=00(>ifc ) Sub=00 Prot=00 MxPS= 8 #Cfgs=  1
  P:  Vendor=0bc7 ProdID=0002 Rev= 1.00
  S:  Manufacturer=X10 Wireless Technology Inc
  S:  Product=USB Transceiver
  C:* #Ifs= 1 Cfg#= 1 Atr=e0 MxPwr=  2mA
  I:  If#= 0 Alt= 0 #EPs= 2 Cls=00(>ifc ) Sub=00 Prot=00 Driver=(none)
  E:  Ad=81(I) Atr=03(Int.) MxPS=   8 Ivl=10ms
  E:  Ad=02(O) Atr=03(Int.) MxPS=   8 Ivl=10ms


Endpoint 81 (Input - read)   Type = Interrupt 8 bytes 10ms
Endpoint 02 (Output - write) Type = Interrupt 8 bytes 10ms

T = Topology (etc.)
B = Bandwidth (applies only to USB host controllers, which are
    virtualized as root hubs)
D = Device descriptor info.
P = Product ID info. (from Device descriptor, but they won't fit
    together on one line)
S = String descriptors.
C = Configuration descriptor info. (* = active configuration)
I = Interface descriptor info.
E = Endpoint descriptor info.

Legend:
  d = decimal number (may have leading spaces or 0's)
  x = hexadecimal number (may have leading spaces or 0's)
  s = string


Topology info:

T:  Bus=dd Lev=dd Prnt=dd Port=dd Cnt=dd Dev#=ddd Spd=ddd MxCh=dd
|   |      |      |       |       |      |        |       |__MaxChildren
|   |      |      |       |       |      |        |__Device Speed in Mbps
|   |      |      |       |       |      |__DeviceNumber
|   |      |      |       |       |__Count of devices at this level
|   |      |      |       |__Connector/Port on Parent for this device
|   |      |      |__Parent DeviceNumber
|   |      |__Level in topology for this bus
|   |__Bus number
|__Topology info tag


Bandwidth info:
B:  Alloc=ddd/ddd us (xx%), #Int=ddd, #Iso=ddd
|   |                       |         |__Number if isochronous requests
|   |                       |__Number of interrupt requests
|   |__Total Bandwidth allocated to this bus
|__Bandwidth info tag


Device descriptor info & Product ID info:

D:  Ver=x.xx Cls=xx(s) Sub=xx Prot=xx MxPS=dd #Cfgs=dd
P:  Vendor=xxxx ProdID=xxxx Rev=xx.xx

where
D:  Ver=x.xx Cls=xx(sssss) Sub=xx Prot=xx MxPS=dd #Cfgs=dd
|   |        |             |      |       |       |__NumberConfigurations
|   |        |             |      |       |__MaxPacketSize of Default Endpoint
|   |        |             |      |__DeviceProtocol
|   |        |             |__DeviceSubClass
|   |        |__DeviceClass
|   |__Device USB version
|__Device info tag #1

where
P:  Vendor=xxxx ProdID=xxxx Rev=xx.xx
|   |           |           |__Product revision number
|   |           |__Product ID code
|   |__Vendor ID code
|__Device info tag #2


String descriptor info:

S:  Manufacturer=ssss
|   |__Manufacturer of this device as read from the device.
|__String info tag

S:  Product=ssss
|   |__Product description of this device as read from the device,
|      except that it is a generated string for USB host controllers
|      (virtual root hubs), in the form "USB *HCI Root Hub".
|__String info tag

S:  SerialNumber=ssss
|   |__Serial Number of this device as read from the device,
|      except that it is a generated string for USB host controllers
|      (virtual root hubs), and represents the host controller's
|      unique identification in the system (currently I/O or
|      memory-mapped base address).
|__String info tag


Configuration descriptor info:

C:  #Ifs=dd Cfg#=dd Atr=xx MPwr=dddmA
|   |       |       |      |__MaxPower in mA
|   |       |       |__Attributes
|   |       |__ConfiguratioNumber
|   |__NumberOfInterfaces
|__Config info tag


Interface descriptor info (can be multiple per Config):

I:  If#=dd Alt=dd #EPs=dd Cls=xx(sssss) Sub=xx Prot=xx Driver=ssss
|   |      |      |       |             |      |       |__Driver name
|   |      |      |       |             |      |__InterfaceProtocol
|   |      |      |       |             |__InterfaceSubClass
|   |      |      |       |__InterfaceClass
|   |      |      |__NumberOfEndpoints
|   |      |__AlternateSettingNumber
|   |__InterfaceNumber
|__Interface info tag


Endpoint descriptor info (can be multiple per Interface):

E:  Ad=xx(s) Atr=xx(ssss) MxPS=dddd Ivl=dddms
E:  Ad=xx(s) Atr=xx(ssss) MxPS=dddd Ivl=dddms
|   |        |            |         |__Interval
|   |        |            |__EndpointMaxPacketSize
|   |        |__Attributes(EndpointType)
|   |__EndpointAddress(I=In,O=Out)
|__Endpoint info tag

The usb_device structure is the root of all USB specific descriptors. Sometimes
it is necessary to parse the descriptors within a driver to configure the device
or to setup transfer requests properly. 

    * Accessing all available configuration descriptors can be done like this:

      for (i = 0; i < dev->descriptor.bNumConfigurations; i++) {
        struct usb_config_descriptor *cfg = &dev->config[i];
        ...
      }

    * Accessing all available interface descriptors of a particular configuration
      is done like this:

      for (j = 0; j < cfg->bNumInterfaces; j++) {
        struct usb_interface *ifp = &cfg->interface[j];
	...
      }

      To start the parsing of the active configuration simply use the
      dev->actconfig pointer.

    * Accessing all alternate settings of a particular interface can be done like
      this:

      for (k = 0; k < ifp->num_altsetting; k++) {
        struct usb_interface_descriptor *as = &ifp->altsetting[k];
	...
      }

      The active alternate setting can be accessed via
      *as = &ifp->altsetting[ifp->act_altsetting]

    * Accessing all endpoint descriptors of a particular alternate setting can
      done like this:

      for(l = 0; l < as->bNumEndpoints; l++) {
        struct usb_endpoint_descriptor *ep=&as->endpoint[k];
	...
      }

Something I just caught:

a1aoff
11/05 16:35:26 ?: 20 00 FF 20 DF 00 00 00
11/05 16:35:26 ?: 20 20 DF 20 DF 00 00 00
11/05 16:35:27 ?: 20 00 FF 20 DF D7 13 40

a2
11/05 16:35:35 ?: 20 20 DF 30 CF 02 20 00
11/05 16:35:35 ?: 20 20 DF 30 CF 02 20 00

a3
11/05 16:35:44 ?: 20 20 DF 28 D7 00 00 00
11/05 16:35:44 ?: 20 20 DF 28 D7 FF FF FF
a4
11/05 16:35:51 ?: 20 20 DF 38 C7 00 00 00
a5
11/05 16:35:57 ?: 20 20 DF 60 9F 00 00 00
a6
11/05 16:36:04 ?: 20 00 FF 70 8F 00 00 00
11/05 16:36:04 ?: 20 00 FF 70 8F CE 08 40
a7
11/05 16:36:10 ?: 20 20 DF 68 97 02 20 00
a8
11/05 16:36:18 ?: 20 20 DF 78 87 00 00 00
11/05 16:36:20 ?: 20 00 FF 78 87 02 20 00
11/05 16:36:21 ?: 20 20 DF 78 87 02 20 00
11/05 16:36:23 ?: 20 20 DF 78 87 00 00 00
11/05 16:36:25 ?: 20 20 DF 78 87 00 00 00
11/05 16:36:26 ?: 20 20 DF 78 87 00 00 00
11/05 16:36:26 ?: 20 20 DF 78 87 4E 01 40
11/05 16:36:26 ?: 20 20 DF 78 87 00 00 00
11/05 16:36:26 ?: 20 20 DF 78 87 00 00 00

dim?
11/05 16:36:48 ?: 20 60 9F 98 67 00 00 00
11/05 16:36:48 ?: 20 60 9F 98 67 00 00 00

bright ?

11/05 16:37:36 ?: 20 00 FF 88 77 00 00 00

a8aon
11/05 16:37:46 ?: 20 00 FF 58 A7 00 00 00
11/05 16:37:46 ?: 20 00 FF 58 A7 02 20 00
a7
11/05 16:37:53 ?: 20 00 FF 48 B7 6B 65 74
11/05 16:37:53 ?: 20 00 FF 48 B7 00 00 00
a6
11/05 16:38:00 ?: 20 60 9F 50 AF 00 00 00
11/05 16:38:00 ?: 20 60 9F 50 AF 00 00 00
a5
11/05 16:38:05 ?: 20 60 9F 40 BF 02 20 00
a4
11/05 16:38:10 ?: 20 60 9F 18 E7 02 20 00
11/05 16:38:10 ?: 20 40 BF 18 E7 B3 FF FF
a3
11/05 16:38:15 ?: 20 60 9F 08 F7 00 00 00
a2
11/05 16:38:23 ?: 20 60 9F 10 EF 00 00 00
a1
11/05 16:38:28 ?: 20 60 9F 00 FF 00 00 00
11/05 16:38:28 ?: 20 60 9F 00 FF 02 20 00
11/05 16:38:36 ?: 20 60 9F 00 FF 00 00 00

A1ON	0x20  0x60  0x9f  0x00  0xff
A1OFF	0x20  0x60  0x9f  0x20  0xdf
A2ON	0x20  0x60  0x9f  0x10  0xef
A2OFF	0x20  0x60  0x9f  0x30  0xcf
A3ON	0x20  0x60  0x9f  0x08  0xf7
A3OFF	0x20  0x60  0x9f  0x28  0xd7
A4ON	0x20  0x60  0x9f  0x18  0xe7
A4OFF	0x20  0x60  0x9f  0x38  0xc7
A5ON	0x20  0x60  0x9f  0x40  0xbf
A5OFF	0x20  0x60  0x9f  0x60  0x9f
A6ON	0x20  0x60  0x9f  0x50  0xaf
A6OFF	0x20  0x60  0x9f  0x70  0x8f
A7ON	0x20  0x60  0x9f  0x48  0xb7
A7OFF	0x20  0x60  0x9f  0x68  0x97
A8ON	0x20  0x60  0x9f  0x58  0xa7
A8OFF	0x20  0x60  0x9f  0x78  0x87
A9ON	0x20  0x64  0x9b  0x00  0xff
A9OFF	0x20  0x64  0x9b  0x20  0xdf
A10ON	0x20  0x64  0x9b  0x10  0xef
A10OFF	0x20  0x64  0x9b  0x30  0xcf
A11ON	0x20  0x64  0x9b  0x08  0xf7
A11OFF	0x20  0x64  0x9b  0x28  0xd7
A12ON	0x20  0x64  0x9b  0x18  0xe7
A12OFF	0x20  0x64  0x9b  0x38  0xc7
A13ON	0x20  0x64  0x9b  0x40  0xbf
A13OFF	0x20  0x64  0x9b  0x60  0x9f
A14ON	0x20  0x64  0x9b  0x50  0xaf
A14OFF	0x20  0x64  0x9b  0x70  0x8f
A15ON	0x20  0x64  0x9b  0x48  0xb7
A15OFF	0x20  0x64  0x9b  0x68  0x97
A16ON	0x20  0x64  0x9b  0x58  0xa7
A16OFF	0x20  0x64  0x9b  0x78  0x87
ABRIGHT	0x20  0x60  0x9f  0x88  0x77
ADIM	0x20  0x60  0x9f  0x98  0x67
ALON	0x20  0x60  0x9f  0x90  0x6f
AUOFF	0x20  0x60  0x9f  0x80  0x7f

B1ON	0x20  0x70  0x8f  0x00  0xff
B1OFF	0x20  0x70  0x8f  0x20  0xdf
B2ON	0x20  0x70  0x8f  0x10  0xef
B2OFF	0x20  0x70  0x8f  0x30  0xcf
B3ON	0x20  0x70  0x8f  0x08  0xf7
B3OFF	0x20  0x70  0x8f  0x28  0xd7
B4ON	0x20  0x70  0x8f  0x18  0xe7
B4OFF	0x20  0x70  0x8f  0x38  0xc7
B5ON	0x20  0x70  0x8f  0x40  0xbf
B5OFF	0x20  0x70  0x8f  0x60  0x9f
B6ON	0x20  0x70  0x8f  0x50  0xaf
B6OFF	0x20  0x70  0x8f  0x70  0x8f
B7ON	0x20  0x70  0x8f  0x48  0xb7
B7OFF	0x20  0x70  0x8f  0x68  0x97
B8ON	0x20  0x70  0x8f  0x58  0xa7
B8OFF	0x20  0x70  0x8f  0x78  0x87
B9ON	0x20  0x74  0x8b  0x00  0xff
B9OFF	0x20  0x74  0x8b  0x20  0xdf
B10ON	0x20  0x74  0x8b  0x10  0xef
B10OFF	0x20  0x74  0x8b  0x30  0xcf
B11ON	0x20  0x74  0x8b  0x08  0xf7
B11OFF	0x20  0x74  0x8b  0x28  0xd7
B12ON	0x20  0x74  0x8b  0x18  0xe7
B12OFF	0x20  0x74  0x8b  0x38  0xc7
B13ON	0x20  0x74  0x8b  0x40  0xbf
B13OFF	0x20  0x74  0x8b  0x60  0x9f
B14ON	0x20  0x74  0x8b  0x50  0xaf
B14OFF	0x20  0x74  0x8b  0x70  0x8f
B15ON	0x20  0x74  0x8b  0x48  0xb7
B15OFF	0x20  0x74  0x8b  0x68  0x97
B16ON	0x20  0x74  0x8b  0x58  0xa7
B16OFF	0x20  0x74  0x8b  0x78  0x87
BBRIGHT	0x20  0x70  0x8f  0x88  0x77
BDIM	0x20  0x70  0x8f  0x98  0x67
BLON	0x20  0x70  0x8f  0x90  0x6f
BUOFF	0x20  0x70  0x8f  0x80  0x7f
C1ON	0x20  0x40  0xbf  0x00  0xff
C1OFF	0x20  0x40  0xbf  0x20  0xdf
C2ON	0x20  0x40  0xbf  0x10  0xef
C2OFF	0x20  0x40  0xbf  0x30  0xcf
C3ON	0x20  0x40  0xbf  0x08  0xf7
C3OFF	0x20  0x40  0xbf  0x28  0xd7
C4ON	0x20  0x40  0xbf  0x18  0xe7
C4OFF	0x20  0x40  0xbf  0x38  0xc7
C5ON	0x20  0x40  0xbf  0x40  0xbf
C5OFF	0x20  0x40  0xbf  0x60  0x9f
C6ON	0x20  0x40  0xbf  0x50  0xaf
C6OFF	0x20  0x40  0xbf  0x70  0x8f
C7ON	0x20  0x40  0xbf  0x48  0xb7
C7OFF	0x20  0x40  0xbf  0x68  0x97
C8ON	0x20  0x40  0xbf  0x58  0xa7
C8OFF	0x20  0x40  0xbf  0x78  0x87
C9ON	0x20  0x44  0xbb  0x00  0xff
C9OFF	0x20  0x44  0xbb  0x20  0xdf
C10ON	0x20  0x44  0xbb  0x10  0xef
C10OFF	0x20  0x44  0xbb  0x30  0xcf
C11ON	0x20  0x44  0xbb  0x08  0xf7
C11OFF	0x20  0x44  0xbb  0x28  0xd7
C12ON	0x20  0x44  0xbb  0x18  0xe7
C12OFF	0x20  0x44  0xbb  0x38  0xc7
C13ON	0x20  0x44  0xbb  0x40  0xbf
C13OFF	0x20  0x44  0xbb  0x60  0x9f
C14ON	0x20  0x44  0xbb  0x50  0xaf
C14OFF	0x20  0x44  0xbb  0x70  0x8f
C15ON	0x20  0x44  0xbb  0x48  0xb7
C15OFF	0x20  0x44  0xbb  0x68  0x97
C16ON	0x20  0x44  0xbb  0x58  0xa7
C16OFF	0x20  0x44  0xbb  0x78  0x87
CBRIGHT	0x20  0x40  0xbf  0x88  0x77
CDIM	0x20  0x40  0xbf  0x98  0x67
CLON	0x20  0x40  0xbf  0x90  0x6f
CUOFF	0x20  0x40  0xbf  0x80  0x7f
D1ON	0x20  0x50  0xaf  0x00  0xff
D1OFF	0x20  0x50  0xaf  0x20  0xdf
D2ON	0x20  0x50  0xaf  0x10  0xef
D2OFF	0x20  0x50  0xaf  0x30  0xcf
D3ON	0x20  0x50  0xaf  0x08  0xf7
D3OFF	0x20  0x50  0xaf  0x28  0xd7
D4ON	0x20  0x50  0xaf  0x18  0xe7
D4OFF	0x20  0x50  0xaf  0x38  0xc7
D5ON	0x20  0x50  0xaf  0x40  0xbf
D5OFF	0x20  0x50  0xaf  0x60  0x9f
D6ON	0x20  0x50  0xaf  0x50  0xaf
D6OFF	0x20  0x50  0xaf  0x70  0x8f
D7ON	0x20  0x50  0xaf  0x48  0xb7
D7OFF	0x20  0x50  0xaf  0x68  0x97
D8ON	0x20  0x50  0xaf  0x58  0xa7
D8OFF	0x20  0x50  0xaf  0x78  0x87
D9ON	0x20  0x54  0xab  0x00  0xff
D9OFF	0x20  0x54  0xab  0x20  0xdf
D10ON	0x20  0x54  0xab  0x10  0xef
D10OFF	0x20  0x54  0xab  0x30  0xcf
D11ON	0x20  0x54  0xab  0x08  0xf7
D11OFF	0x20  0x54  0xab  0x28  0xd7
D12ON	0x20  0x54  0xab  0x18  0xe7
D12OFF	0x20  0x54  0xab  0x38  0xc7
D13ON	0x20  0x54  0xab  0x40  0xbf
D13OFF	0x20  0x54  0xab  0x60  0x9f
D14ON	0x20  0x54  0xab  0x50  0xaf
D14OFF	0x20  0x54  0xab  0x70  0x8f
D15ON	0x20  0x54  0xab  0x48  0xb7
D15OFF	0x20  0x54  0xab  0x68  0x97
D16ON	0x20  0x54  0xab  0x58  0xa7
D16OFF	0x20  0x54  0xab  0x78  0x87
DBRIGHT	0x20  0x50  0xaf  0x88  0x77
DDIM	0x20  0x50  0xaf  0x98  0x67
DLON	0x20  0x50  0xaf  0x90  0x6f
DUOFF	0x20  0x50  0xaf  0x80  0x7f
E1ON	0x20  0x80  0x7f  0x00  0xff
E1OFF	0x20  0x80  0x7f  0x20  0xdf
E2ON	0x20  0x80  0x7f  0x10  0xef
E2OFF	0x20  0x80  0x7f  0x30  0xcf
E3ON	0x20  0x80  0x7f  0x08  0xf7
E3OFF	0x20  0x80  0x7f  0x28  0xd7
E4ON	0x20  0x80  0x7f  0x18  0xe7
E4OFF	0x20  0x80  0x7f  0x38  0xc7
E5ON	0x20  0x80  0x7f  0x40  0xbf
E5OFF	0x20  0x80  0x7f  0x60  0x9f
E6ON	0x20  0x80  0x7f  0x50  0xaf
E6OFF	0x20  0x80  0x7f  0x70  0x8f
E7ON	0x20  0x80  0x7f  0x48  0xb7
E7OFF	0x20  0x80  0x7f  0x68  0x97
E8ON	0x20  0x80  0x7f  0x58  0xa7
E8OFF	0x20  0x80  0x7f  0x78  0x87
E9ON	0x20  0x84  0x7b  0x00  0xff
E9OFF	0x20  0x84  0x7b  0x20  0xdf
E10ON	0x20  0x84  0x7b  0x10  0xef
E10OFF	0x20  0x84  0x7b  0x30  0xcf
E11ON	0x20  0x84  0x7b  0x08  0xf7
E11OFF	0x20  0x84  0x7b  0x28  0xd7
E12ON	0x20  0x84  0x7b  0x18  0xe7
E12OFF	0x20  0x84  0x7b  0x38  0xc7
E13ON	0x20  0x84  0x7b  0x40  0xbf
E13OFF	0x20  0x84  0x7b  0x60  0x9f
E14ON	0x20  0x84  0x7b  0x50  0xaf
E14OFF	0x20  0x84  0x7b  0x70  0x8f
E15ON	0x20  0x84  0x7b  0x48  0xb7
E15OFF	0x20  0x84  0x7b  0x68  0x97
E16ON	0x20  0x84  0x7b  0x58  0xa7
E16OFF	0x20  0x84  0x7b  0x78  0x87
EBRIGHT	0x20  0x80  0x7f  0x88  0x77
EDIM	0x20  0x80  0x7f  0x98  0x67
ELON	0x20  0x80  0x7f  0x90  0x6f
EUOFF	0x20  0x80  0x7f  0x80  0x7f
F1ON	0x20  0x90  0x6f  0x00  0xff
F1OFF	0x20  0x90  0x6f  0x20  0xdf
F2ON	0x20  0x90  0x6f  0x10  0xef
F2OFF	0x20  0x90  0x6f  0x30  0xcf
F3ON	0x20  0x90  0x6f  0x08  0xf7
F3OFF	0x20  0x90  0x6f  0x28  0xd7
F4ON	0x20  0x90  0x6f  0x18  0xe7
F4OFF	0x20  0x90  0x6f  0x38  0xc7
F5ON	0x20  0x90  0x6f  0x40  0xbf
F5OFF	0x20  0x90  0x6f  0x60  0x9f
F6ON	0x20  0x90  0x6f  0x50  0xaf
F6OFF	0x20  0x90  0x6f  0x70  0x8f
F7ON	0x20  0x90  0x6f  0x48  0xb7
F7OFF	0x20  0x90  0x6f  0x68  0x97
F8ON	0x20  0x90  0x6f  0x58  0xa7
F8OFF	0x20  0x90  0x6f  0x78  0x87
F9ON	0x20  0x94  0x6b  0x00  0xff
F9OFF	0x20  0x94  0x6b  0x20  0xdf
F10ON	0x20  0x94  0x6b  0x10  0xef
F10OFF	0x20  0x94  0x6b  0x30  0xcf
F11ON	0x20  0x94  0x6b  0x08  0xf7
F11OFF	0x20  0x94  0x6b  0x28  0xd7
F12ON	0x20  0x94  0x6b  0x18  0xe7
F12OFF	0x20  0x94  0x6b  0x38  0xc7
F13ON	0x20  0x94  0x6b  0x40  0xbf
F13OFF	0x20  0x94  0x6b  0x60  0x9f
F14ON	0x20  0x94  0x6b  0x50  0xaf
F14OFF	0x20  0x94  0x6b  0x70  0x8f
F15ON	0x20  0x94  0x6b  0x48  0xb7
F15OFF	0x20  0x94  0x6b  0x68  0x97
F16ON	0x20  0x94  0x6b  0x58  0xa7
F16OFF	0x20  0x94  0x6b  0x78  0x87
FBRIGHT	0x20  0x90  0x6f  0x88  0x77
FDIM	0x20  0x90  0x6f  0x98  0x67
FLON	0x20  0x90  0x6f  0x90  0x6f
FUOFF	0x20  0x90  0x6f  0x80  0x7f
G1ON	0x20  0xa0  0x5f  0x00  0xff
G1OFF	0x20  0xa0  0x5f  0x20  0xdf
G2ON	0x20  0xa0  0x5f  0x10  0xef
G2OFF	0x20  0xa0  0x5f  0x30  0xcf
G3ON	0x20  0xa0  0x5f  0x08  0xf7
G3OFF	0x20  0xa0  0x5f  0x28  0xd7
G4ON	0x20  0xa0  0x5f  0x18  0xe7
G4OFF	0x20  0xa0  0x5f  0x38  0xc7
G5ON	0x20  0xa0  0x5f  0x40  0xbf
G5OFF	0x20  0xa0  0x5f  0x60  0x9f
G6ON	0x20  0xa0  0x5f  0x50  0xaf
G6OFF	0x20  0xa0  0x5f  0x70  0x8f
G7ON	0x20  0xa0  0x5f  0x48  0xb7
G7OFF	0x20  0xa0  0x5f  0x68  0x97
G8ON	0x20  0xa0  0x5f  0x58  0xa7
G8OFF	0x20  0xa0  0x5f  0x78  0x87
G9ON	0x20  0xa4  0x5b  0x00  0xff
G9OFF	0x20  0xa4  0x5b  0x20  0xdf
G10ON	0x20  0xa4  0x5b  0x10  0xef
G10OFF	0x20  0xa4  0x5b  0x30  0xcf
G11ON	0x20  0xa4  0x5b  0x08  0xf7
G11OFF	0x20  0xa4  0x5b  0x28  0xd7
G12ON	0x20  0xa4  0x5b  0x18  0xe7
G12OFF	0x20  0xa4  0x5b  0x38  0xc7
G13ON	0x20  0xa4  0x5b  0x40  0xbf
G13OFF	0x20  0xa4  0x5b  0x60  0x9f
G14ON	0x20  0xa4  0x5b  0x50  0xaf
G14OFF	0x20  0xa4  0x5b  0x70  0x8f
G15ON	0x20  0xa4  0x5b  0x48  0xb7
G15OFF	0x20  0xa4  0x5b  0x68  0x97
G16ON	0x20  0xa4  0x5b  0x58  0xa7
G16OFF	0x20  0xa4  0x5b  0x78  0x87
GBRIGHT	0x20  0xa0  0x5f  0x88  0x77
GDIM	0x20  0xa0  0x5f  0x98  0x67
GLON	0x20  0xa0  0x5f  0x90  0x6f
GUOFF	0x20  0xa0  0x5f  0x80  0x7f
H1ON	0x20  0xb0  0x4f  0x00  0xff
H1OFF	0x20  0xb0  0x4f  0x20  0xdf
H2ON	0x20  0xb0  0x4f  0x10  0xef
H2OFF	0x20  0xb0  0x4f  0x30  0xcf
H3ON	0x20  0xb0  0x4f  0x08  0xf7
H3OFF	0x20  0xb0  0x4f  0x28  0xd7
H4ON	0x20  0xb0  0x4f  0x18  0xe7
H4OFF	0x20  0xb0  0x4f  0x38  0xc7
H5ON	0x20  0xb0  0x4f  0x40  0xbf
H5OFF	0x20  0xb0  0x4f  0x60  0x9f
H6ON	0x20  0xb0  0x4f  0x50  0xaf
H6OFF	0x20  0xb0  0x4f  0x70  0x8f
H7ON	0x20  0xb0  0x4f  0x48  0xb7
H7OFF	0x20  0xb0  0x4f  0x68  0x97
H8ON	0x20  0xb0  0x4f  0x58  0xa7
H8OFF	0x20  0xb0  0x4f  0x78  0x87
H9ON	0x20  0xb4  0x4b  0x00  0xff
H9OFF	0x20  0xb4  0x4b  0x20  0xdf
H10ON	0x20  0xb4  0x4b  0x10  0xef
H10OFF	0x20  0xb4  0x4b  0x30  0xcf
H11ON	0x20  0xb4  0x4b  0x08  0xf7
H11OFF	0x20  0xb4  0x4b  0x28  0xd7
H12ON	0x20  0xb4  0x4b  0x18  0xe7
H12OFF	0x20  0xb4  0x4b  0x38  0xc7
H13ON	0x20  0xb4  0x4b  0x40  0xbf
H13OFF	0x20  0xb4  0x4b  0x60  0x9f
H14ON	0x20  0xb4  0x4b  0x50  0xaf
H14OFF	0x20  0xb4  0x4b  0x70  0x8f
H15ON	0x20  0xb4  0x4b  0x48  0xb7
H15OFF	0x20  0xb4  0x4b  0x68  0x97
H16ON	0x20  0xb4  0x4b  0x58  0xa7
H16OFF	0x20  0xb4  0x4b  0x78  0x87
HBRIGHT	0x20  0xb0  0x4f  0x88  0x77
HDIM	0x20  0xb0  0x4f  0x98  0x67
HLON	0x20  0xb0  0x4f  0x90  0x6f
HUOFF	0x20  0xb0  0x4f  0x80  0x7f
I1ON	0x20  0xe0  0x1f  0x00  0xff
I1OFF	0x20  0xe0  0x1f  0x20  0xdf
I2ON	0x20  0xe0  0x1f  0x10  0xef
I2OFF	0x20  0xe0  0x1f  0x30  0xcf
I3ON	0x20  0xe0  0x1f  0x08  0xf7
I3OFF	0x20  0xe0  0x1f  0x28  0xd7
I4ON	0x20  0xe0  0x1f  0x18  0xe7
I4OFF	0x20  0xe0  0x1f  0x38  0xc7
I5ON	0x20  0xe0  0x1f  0x40  0xbf
I5OFF	0x20  0xe0  0x1f  0x60  0x9f
I6ON	0x20  0xe0  0x1f  0x50  0xaf
I6OFF	0x20  0xe0  0x1f  0x70  0x8f
I7ON	0x20  0xe0  0x1f  0x48  0xb7
I7OFF	0x20  0xe0  0x1f  0x68  0x97
I8ON	0x20  0xe0  0x1f  0x58  0xa7
I8OFF	0x20  0xe0  0x1f  0x78  0x87
I9ON	0x20  0xe4  0x1b  0x00  0xff
I9OFF	0x20  0xe4  0x1b  0x20  0xdf
I10ON	0x20  0xe4  0x1b  0x10  0xef
I10OFF	0x20  0xe4  0x1b  0x30  0xcf
I11ON	0x20  0xe4  0x1b  0x08  0xf7
I11OFF	0x20  0xe4  0x1b  0x28  0xd7
I12ON	0x20  0xe4  0x1b  0x18  0xe7
I12OFF	0x20  0xe4  0x1b  0x38  0xc7
I13ON	0x20  0xe4  0x1b  0x40  0xbf
I13OFF	0x20  0xe4  0x1b  0x60  0x9f
I14ON	0x20  0xe4  0x1b  0x50  0xaf
I14OFF	0x20  0xe4  0x1b  0x70  0x8f
I15ON	0x20  0xe4  0x1b  0x48  0xb7
I15OFF	0x20  0xe4  0x1b  0x68  0x97
I16ON	0x20  0xe4  0x1b  0x58  0xa7
I16OFF	0x20  0xe4  0x1b  0x78  0x87
IBRIGHT	0x20  0xe0  0x1f  0x88  0x77
IDIM	0x20  0xe0  0x1f  0x98  0x67
ILON	0x20  0xe0  0x1f  0x90  0x6f
IUOFF	0x20  0xe0  0x1f  0x80  0x7f
J1ON	0x20  0xf0  0x0f  0x00  0xff
J1OFF	0x20  0xf0  0x0f  0x20  0xdf
J2ON	0x20  0xf0  0x0f  0x10  0xef
J2OFF	0x20  0xf0  0x0f  0x30  0xcf
J3ON	0x20  0xf0  0x0f  0x08  0xf7
J3OFF	0x20  0xf0  0x0f  0x28  0xd7
J4ON	0x20  0xf0  0x0f  0x18  0xe7
J4OFF	0x20  0xf0  0x0f  0x38  0xc7
J5ON	0x20  0xf0  0x0f  0x40  0xbf
J5OFF	0x20  0xf0  0x0f  0x60  0x9f
J6ON	0x20  0xf0  0x0f  0x50  0xaf
J6OFF	0x20  0xf0  0x0f  0x70  0x8f
J7ON	0x20  0xf0  0x0f  0x48  0xb7
J7OFF	0x20  0xf0  0x0f  0x68  0x97
J8ON	0x20  0xf0  0x0f  0x58  0xa7
J8OFF	0x20  0xf0  0x0f  0x78  0x87
J9ON	0x20  0xf4  0x0b  0x00  0xff
J9OFF	0x20  0xf4  0x0b  0x20  0xdf
J10ON	0x20  0xf4  0x0b  0x10  0xef
J10OFF	0x20  0xf4  0x0b  0x30  0xcf
J11ON	0x20  0xf4  0x0b  0x08  0xf7
J11OFF	0x20  0xf4  0x0b  0x28  0xd7
J12ON	0x20  0xf4  0x0b  0x18  0xe7
J12OFF	0x20  0xf4  0x0b  0x38  0xc7
J13ON	0x20  0xf4  0x0b  0x40  0xbf
J13OFF	0x20  0xf4  0x0b  0x60  0x9f
J14ON	0x20  0xf4  0x0b  0x50  0xaf
J14OFF	0x20  0xf4  0x0b  0x70  0x8f
J15ON	0x20  0xf4  0x0b  0x48  0xb7
J15OFF	0x20  0xf4  0x0b  0x68  0x97
J16ON	0x20  0xf4  0x0b  0x58  0xa7
J16OFF	0x20  0xf4  0x0b  0x78  0x87
JBRIGHT	0x20  0xf0  0x0f  0x88  0x77
JDIM	0x20  0xf0  0x0f  0x98  0x67
JLON	0x20  0xf0  0x0f  0x90  0x6f
JUOFF	0x20  0xf0  0x0f  0x80  0x7f
K1ON	0x20  0xc0  0x3f  0x00  0xff
K1OFF	0x20  0xc0  0x3f  0x20  0xdf
K2ON	0x20  0xc0  0x3f  0x10  0xef
K2OFF	0x20  0xc0  0x3f  0x30  0xcf
K3ON	0x20  0xc0  0x3f  0x08  0xf7
K3OFF	0x20  0xc0  0x3f  0x28  0xd7
K4ON	0x20  0xc0  0x3f  0x18  0xe7
K4OFF	0x20  0xc0  0x3f  0x38  0xc7
K5ON	0x20  0xc0  0x3f  0x40  0xbf
K5OFF	0x20  0xc0  0x3f  0x60  0x9f
K6ON	0x20  0xc0  0x3f  0x50  0xaf
K6OFF	0x20  0xc0  0x3f  0x70  0x8f
K7ON	0x20  0xc0  0x3f  0x48  0xb7
K7OFF	0x20  0xc0  0x3f  0x68  0x97
K8ON	0x20  0xc0  0x3f  0x58  0xa7
K8OFF	0x20  0xc0  0x3f  0x78  0x87
K9ON	0x20  0xc4  0x3b  0x00  0xff
K9OFF	0x20  0xc4  0x3b  0x20  0xdf
K10ON	0x20  0xc4  0x3b  0x10  0xef
K10OFF	0x20  0xc4  0x3b  0x30  0xcf
K11ON	0x20  0xc4  0x3b  0x08  0xf7
K11OFF	0x20  0xc4  0x3b  0x28  0xd7
K12ON	0x20  0xc4  0x3b  0x18  0xe7
K12OFF	0x20  0xc4  0x3b  0x38  0xc7
K13ON	0x20  0xc4  0x3b  0x40  0xbf
K13OFF	0x20  0xc4  0x3b  0x60  0x9f
K14ON	0x20  0xc4  0x3b  0x50  0xaf
K14OFF	0x20  0xc4  0x3b  0x70  0x8f
K15ON	0x20  0xc4  0x3b  0x48  0xb7
K15OFF	0x20  0xc4  0x3b  0x68  0x97
K16ON	0x20  0xc4  0x3b  0x58  0xa7
K16OFF	0x20  0xc4  0x3b  0x78  0x87
KBRIGHT	0x20  0xc0  0x3f  0x88  0x77
KDIM	0x20  0xc0  0x3f  0x98  0x67
KLON	0x20  0xc0  0x3f  0x90  0x6f
KUOFF	0x20  0xc0  0x3f  0x80  0x7f
L1ON	0x20  0xd0  0x2f  0x00  0xff
L1OFF	0x20  0xd0  0x2f  0x20  0xdf
L2ON	0x20  0xd0  0x2f  0x10  0xef
L2OFF	0x20  0xd0  0x2f  0x30  0xcf
L3ON	0x20  0xd0  0x2f  0x08  0xf7
L3OFF	0x20  0xd0  0x2f  0x28  0xd7
L4ON	0x20  0xd0  0x2f  0x18  0xe7
L4OFF	0x20  0xd0  0x2f  0x38  0xc7
L5ON	0x20  0xd0  0x2f  0x40  0xbf
L5OFF	0x20  0xd0  0x2f  0x60  0x9f
L6ON	0x20  0xd0  0x2f  0x50  0xaf
L6OFF	0x20  0xd0  0x2f  0x70  0x8f
L7ON	0x20  0xd0  0x2f  0x48  0xb7
L7OFF	0x20  0xd0  0x2f  0x68  0x97
L8ON	0x20  0xd0  0x2f  0x58  0xa7
L8OFF	0x20  0xd0  0x2f  0x78  0x87
L9ON	0x20  0xd4  0x2b  0x00  0xff
L9OFF	0x20  0xd4  0x2b  0x20  0xdf
L10ON	0x20  0xd4  0x2b  0x10  0xef
L10OFF	0x20  0xd4  0x2b  0x30  0xcf
L11ON	0x20  0xd4  0x2b  0x08  0xf7
L11OFF	0x20  0xd4  0x2b  0x28  0xd7
L12ON	0x20  0xd4  0x2b  0x18  0xe7
L12OFF	0x20  0xd4  0x2b  0x38  0xc7
L13ON	0x20  0xd4  0x2b  0x40  0xbf
L13OFF	0x20  0xd4  0x2b  0x60  0x9f
L14ON	0x20  0xd4  0x2b  0x50  0xaf
L14OFF	0x20  0xd4  0x2b  0x70  0x8f
L15ON	0x20  0xd4  0x2b  0x48  0xb7
L15OFF	0x20  0xd4  0x2b  0x68  0x97
L16ON	0x20  0xd4  0x2b  0x58  0xa7
L16OFF	0x20  0xd4  0x2b  0x78  0x87
LBRIGHT	0x20  0xd0  0x2f  0x88  0x77
LDIM	0x20  0xd0  0x2f  0x98  0x67
LLON	0x20  0xd0  0x2f  0x90  0x6f
LUOFF	0x20  0xd0  0x2f  0x80  0x7f
M1ON	0x20  0x00  0xff  0x00  0xff
M1OFF	0x20  0x00  0xff  0x20  0xdf
M2ON	0x20  0x00  0xff  0x10  0xef
M2OFF	0x20  0x00  0xff  0x30  0xcf
M3ON	0x20  0x00  0xff  0x08  0xf7
M3OFF	0x20  0x00  0xff  0x28  0xd7
M4ON	0x20  0x00  0xff  0x18  0xe7
M4OFF	0x20  0x00  0xff  0x38  0xc7
M5ON	0x20  0x00  0xff  0x40  0xbf
M5OFF	0x20  0x00  0xff  0x60  0x9f
M6ON	0x20  0x00  0xff  0x50  0xaf
M6OFF	0x20  0x00  0xff  0x70  0x8f
M7ON	0x20  0x00  0xff  0x48  0xb7
M7OFF	0x20  0x00  0xff  0x68  0x97
M8ON	0x20  0x00  0xff  0x58  0xa7
M8OFF	0x20  0x00  0xff  0x78  0x87
M9ON	0x20  0x04  0xfb  0x00  0xff
M9OFF	0x20  0x04  0xfb  0x20  0xdf
M10ON	0x20  0x04  0xfb  0x10  0xef
M10OFF	0x20  0x04  0xfb  0x30  0xcf
M11ON	0x20  0x04  0xfb  0x08  0xf7
M11OFF	0x20  0x04  0xfb  0x28  0xd7
M12ON	0x20  0x04  0xfb  0x18  0xe7
M12OFF	0x20  0x04  0xfb  0x38  0xc7
M13ON	0x20  0x04  0xfb  0x40  0xbf
M13OFF	0x20  0x04  0xfb  0x60  0x9f
M14ON	0x20  0x04  0xfb  0x50  0xaf
M14OFF	0x20  0x04  0xfb  0x70  0x8f
M15ON	0x20  0x04  0xfb  0x48  0xb7
M15OFF	0x20  0x04  0xfb  0x68  0x97
M16ON	0x20  0x04  0xfb  0x58  0xa7
M16OFF	0x20  0x04  0xfb  0x78  0x87
MBRIGHT	0x20  0x00  0xff  0x88  0x77
MDIM	0x20  0x00  0xff  0x98  0x67
MLON	0x20  0x00  0xff  0x90  0x6f
MUOFF	0x20  0x00  0xff  0x80  0x7f
N1ON	0x20  0x10  0xef  0x00  0xff
N1OFF	0x20  0x10  0xef  0x20  0xdf
N2ON	0x20  0x10  0xef  0x10  0xef
N2OFF	0x20  0x10  0xef  0x30  0xcf
N3ON	0x20  0x10  0xef  0x08  0xf7
N3OFF	0x20  0x10  0xef  0x28  0xd7
N4ON	0x20  0x10  0xef  0x18  0xe7
N4OFF	0x20  0x10  0xef  0x38  0xc7
N5ON	0x20  0x10  0xef  0x40  0xbf
N5OFF	0x20  0x10  0xef  0x60  0x9f
N6ON	0x20  0x10  0xef  0x50  0xaf
N6OFF	0x20  0x10  0xef  0x70  0x8f
N7ON	0x20  0x10  0xef  0x48  0xb7
N7OFF	0x20  0x10  0xef  0x68  0x97
N8ON	0x20  0x10  0xef  0x58  0xa7
N8OFF	0x20  0x10  0xef  0x78  0x87
N9ON	0x20  0x14  0xeb  0x00  0xff
N9OFF	0x20  0x14  0xeb  0x20  0xdf
N10ON	0x20  0x14  0xeb  0x10  0xef
N10OFF	0x20  0x14  0xeb  0x30  0xcf
N11ON	0x20  0x14  0xeb  0x08  0xf7
N11OFF	0x20  0x14  0xeb  0x28  0xd7
N12ON	0x20  0x14  0xeb  0x18  0xe7
N12OFF	0x20  0x14  0xeb  0x38  0xc7
N13ON	0x20  0x14  0xeb  0x40  0xbf
N13OFF	0x20  0x14  0xeb  0x60  0x9f
N14ON	0x20  0x14  0xeb  0x50  0xaf
N14OFF	0x20  0x14  0xeb  0x70  0x8f
N15ON	0x20  0x14  0xeb  0x48  0xb7
N15OFF	0x20  0x14  0xeb  0x68  0x97
N16ON	0x20  0x14  0xeb  0x58  0xa7
N16OFF	0x20  0x14  0xeb  0x78  0x87
NBRIGHT	0x20  0x10  0xef  0x88  0x77
NDIM	0x20  0x10  0xef  0x98  0x67
NLON	0x20  0x10  0xef  0x90  0x6f
NUOFF	0x20  0x10  0xef  0x80  0x7f
O1ON	0x20  0x20  0xdf  0x00  0xff
O1OFF	0x20  0x20  0xdf  0x20  0xdf
O2ON	0x20  0x20  0xdf  0x10  0xef
O2OFF	0x20  0x20  0xdf  0x30  0xcf
O3ON	0x20  0x20  0xdf  0x08  0xf7
O3OFF	0x20  0x20  0xdf  0x28  0xd7
O4ON	0x20  0x20  0xdf  0x18  0xe7
O4OFF	0x20  0x20  0xdf  0x38  0xc7
O5ON	0x20  0x20  0xdf  0x40  0xbf
O5OFF	0x20  0x20  0xdf  0x60  0x9f
O6ON	0x20  0x20  0xdf  0x50  0xaf
O6OFF	0x20  0x20  0xdf  0x70  0x8f
O7ON	0x20  0x20  0xdf  0x48  0xb7
O7OFF	0x20  0x20  0xdf  0x68  0x97
O8ON	0x20  0x20  0xdf  0x58  0xa7
O8OFF	0x20  0x20  0xdf  0x78  0x87
O9ON	0x20  0x24  0xdb  0x00  0xff
O9OFF	0x20  0x24  0xdb  0x20  0xdf
O10ON	0x20  0x24  0xdb  0x10  0xef
O10OFF	0x20  0x24  0xdb  0x30  0xcf
O11ON	0x20  0x24  0xdb  0x08  0xf7
O11OFF	0x20  0x24  0xdb  0x28  0xd7
O12ON	0x20  0x24  0xdb  0x18  0xe7
O12OFF	0x20  0x24  0xdb  0x38  0xc7
O13ON	0x20  0x24  0xdb  0x40  0xbf
O13OFF	0x20  0x24  0xdb  0x60  0x9f
O14ON	0x20  0x24  0xdb  0x50  0xaf
O14OFF	0x20  0x24  0xdb  0x70  0x8f
O15ON	0x20  0x24  0xdb  0x48  0xb7
O15OFF	0x20  0x24  0xdb  0x68  0x97
O16ON	0x20  0x24  0xdb  0x58  0xa7
O16OFF	0x20  0x24  0xdb  0x78  0x87
OBRIGHT	0x20  0x20  0xdf  0x88  0x77
ODIM	0x20  0x20  0xdf  0x98  0x67
OLON	0x20  0x20  0xdf  0x90  0x6f
OUOFF	0x20  0x20  0xdf  0x80  0x7f
P1ON	0x20  0x30  0xcf  0x00  0xff
P1OFF	0x20  0x30  0xcf  0x20  0xdf
P2ON	0x20  0x30  0xcf  0x10  0xef
P2OFF	0x20  0x30  0xcf  0x30  0xcf
P3ON	0x20  0x30  0xcf  0x08  0xf7
P3OFF	0x20  0x30  0xcf  0x28  0xd7
P4ON	0x20  0x30  0xcf  0x18  0xe7
P4OFF	0x20  0x30  0xcf  0x38  0xc7
P5ON	0x20  0x30  0xcf  0x40  0xbf
P5OFF	0x20  0x30  0xcf  0x60  0x9f
P6ON	0x20  0x30  0xcf  0x50  0xaf
P6OFF	0x20  0x30  0xcf  0x70  0x8f
P7ON	0x20  0x30  0xcf  0x48  0xb7
P7OFF	0x20  0x30  0xcf  0x68  0x97
P8ON	0x20  0x30  0xcf  0x58  0xa7
P8OFF	0x20  0x30  0xcf  0x78  0x87
P9ON	0x20  0x34  0xcb  0x00  0xff
P9OFF	0x20  0x34  0xcb  0x20  0xdf
P10ON	0x20  0x34  0xcb  0x10  0xef
P10OFF	0x20  0x34  0xcb  0x30  0xcf
P11ON	0x20  0x34  0xcb  0x08  0xf7
P11OFF	0x20  0x34  0xcb  0x28  0xd7
P12ON	0x20  0x34  0xcb  0x18  0xe7
P12OFF	0x20  0x34  0xcb  0x38  0xc7
P13ON	0x20  0x34  0xcb  0x40  0xbf
P13OFF	0x20  0x34  0xcb  0x60  0x9f
P14ON	0x20  0x34  0xcb  0x50  0xaf
P14OFF	0x20  0x34  0xcb  0x70  0x8f
P15ON	0x20  0x34  0xcb  0x48  0xb7
P15OFF	0x20  0x34  0xcb  0x68  0x97
P16ON	0x20  0x34  0xcb  0x58  0xa7
P16OFF	0x20  0x34  0xcb  0x78  0x87
PBRIGHT	0x20  0x30  0xcf  0x88  0x77
PDIM	0x20  0x30  0xcf  0x98  0x67
PLON	0x20  0x30  0xcf  0x90  0x6f
PUOFF	0x20  0x30  0xcf  0x80  0x7f

*/

